from numpy import *
from pylab import *

# I define the parameters
Np=200 #Number of grid points
L=20 #length of the discretized domain
W=10  #width of the potential well
hbar=1.05459e-34 #eV
q=1.60219e-19    #C
m0=9.1095e-31    #Kg

#I create the grid
x=linspace(0,L,Np) # in nanometers

#I create the potential U(x) for the well
ind=nonzero(abs(x-L*0.5)>W*0.5);
U=zeros(Np);
U[ind]=10 #The height of the barrier is 2 eV


# Uncomment these three lines to plot the potential and exit
#plot(x,U,'o-')
#show()
#exit(0);

#I create the hopping parameter -hbar**2/(2m0*a**2)
a=x[1]-x[0]
t=-hbar**2/(2*m0*(a*1e-9)**2)/q #eV

#I create the diagonal, updiagonal and lowdiagonal vectors
diago=(U-2*t)*(ones(Np));
lowdiag=t*ones(Np-1);
updiag=t*ones(Np-1);

#I create the Hamiltonian
H=diag(diago)+diag(lowdiag,-1)+diag(updiag,1)
H=array(H)
#H=mat(H)

[E,V]=eig(H)
print (hbar*pi/W*1e9)**2/2/m0/q,min(E)
# I plot the eigenvalues
#for i in range(0,Np):
#	plot(x,E[i]*ones(Np))


#I plot the first 3 eigenfunctions
#plot(x,V[:,0])
#plot(x,V[:,1])
#plot(x,V[:,2])

#show();



    






